=== debian/changelog ===
log4cxx (0.12.1-4) unstable; urgency=medium

  * Upload to unstable.

 -- Tobias Frost <tobi@debian.org>  Sun, 09 Jan 2022 16:46:56 +0100

log4cxx (0.12.1-3) experimental; urgency=medium

  * Try to get the liblog4cxx-docs reproducible.

 -- Tobias Frost <tobi@debian.org>  Fri, 07 Jan 2022 19:09:52 +0100

log4cxx (0.12.1-2) experimental; urgency=medium

  * Remove B-Ds for socketservertestcase, as those are failing on certain
    buildds not allowing localhost connections.

 -- Tobias Frost <tobi@debian.org>  Fri, 07 Jan 2022 16:47:53 +0100

log4cxx (0.12.1-1) experimental; urgency=medium

  * New upstream version.
  * Upload to experimental due to the SONAME bump.
  * Prepare packagenames and d/control for the new SONAME.
  * Upstream changed to cmake -- change d/rules and d/clean accordingly.
    - install new cmake module in the -dev package.
    - does no longer build the static library, so remove it from the package.
    - Drop d/not-installed, no longer needed.
    - Build doxygen doc with new upstream cmake build system and adapt
      d/rules and d/*-doc.docs accordingly.
    - Adapt autopkgtests and treat flaky tests special.
  * New patches:
    - Fix pkgconfig and cmake module install paths.
    - Fix parallel execution of the testsuite.
    - Use packaged liblog4j-1.2 (used for testsuite only).
    - Properly escape sed expression (sued for testsuite only).
  * Update d/clean for new version.
    - delete test output artifacts.
    - delete (unusused) minified javascript files.
  * Update examples packaging.
  * Update linitan overrides.
  * B-D on default-jdk and liblog4j1.2-java for tests.
  * Apply nodoc and nocheck build-profiles.
  * Fix linitan overrides for source.
  * Update d/copyright years.
  * Add upstream metadata.
  * Bump S-V to 4.6.0 -- no changes required.
  * Update d/watch to version 4

 -- Tobias Frost <tobi@debian.org>  Tue, 14 Dec 2021 18:49:00 +0100

log4cxx (0.11.0-3) unstable; urgency=medium

  * Remove unused autopkgtest.patch
  * Remove overrides for no-upstream-changelog, lintian removed that tag.

 -- Tobias Frost <tobi@debian.org>  Sun, 05 Dec 2021 12:17:54 +0100
