=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ https://www.apache.org/dist/logging/log4cxx/(?:[\d\.]+)/apache-log4cxx-([\d\.]+)\.tar\.gz
